version: '3.7'

services:

  orientdb:
    image: orientdb:3.0.17
    container_name: orientdb
    # volumes:
      # - ./orientdb/config:/orientdb/config
      # - ./orientdb/databases:/orientdb/databases
    environment:
      ORIENTDB_ROOT_PASSWORD: password
      ORIENTDB_NODE_NAME: node-1
    entrypoint: ["sh", "-c", "./bin/console.sh 'CREATE DATABASE plocal:./databases/sbo_db'; server.sh"]
    ports:
      - 2480:2480
      - 2424:2424

  gremlin:
    build:
      context: ./gremlin
    image: gremlin-orientdb
    container_name: gremlin
    # volumes:
    # - ./gremlin/conf:/opt/gremlin-server/conf
    entrypoint: ["./wait-for","orientdb:2480","--","/docker-entrypoint.sh","conf/orientdb-server.yaml"]
    depends_on:
      - orientdb
    ports:
      - 8182:8182

  application:
    build:
      context: .
    image: spring-boot-gremlin-orientdb
    container_name: spring-boot-gremlin-orientdb
    environment:
      GREMLIN_ENDPOINT: gremlin
    command: ["./wait-for","gremlin:8182","--","java","-Djava.security.egd=file:/dev/./urandom","-jar","/app.jar"]
    depends_on:
      - gremlin
      - orientdb
    ports:
      - 8080:8080